#include <stdio.h>
#include <string.h>
#include "stdlib.h"
#include "CH563SFR.H"
#include "SYSFREQ.H"
#include "TFTP.H"
#include "CH563NET.H"
#include "ISPXT56X.H"
  
 /*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void mInitSTDIO( void )
{
    UINT32    x, x2;

    x = 10 * FREQ_SYS * 2 / 16 / 256000;                                                            /* 115200bps */                                             
    x2 = x % 10;                                                                                                                                                
    x /= 10;                                                                                                                                                    
    if ( x2 >= 5 ) x ++;                                                                            /*  */                                              
    R8_UART1_LCR = 0x80;                                                                            /* DLABλ1 */                                             
    R8_UART1_DIV = 1;                                                                               /* ԤƵ */                                                
    R8_UART1_DLM = x>>8;                                                                                                                                        
    R8_UART1_DLL = x&0xff;                                                                                                                                      
                                                                                                                                                                
    R8_UART1_LCR = RB_LCR_WORD_SZ ;                                                                 /* ֽڳΪ8 */                                       
    R8_UART1_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR |                                                                                     
                   RB_FCR_FIFO_EN ;                                                                 /* FIFOΪ14巢ͺͽFIFOFIFOʹ */        
    R8_UART1_IER = RB_IER_TXD_EN;                                                                   /* TXD enable */                                            
    R32_PB_SMT |= RXD1|TXD1;                                                                        /* RXD0 schmitt input, TXD0 slow rate */                    
    R32_PB_PD &= ~ RXD1;                                                                            /* disable pulldown for RXD0, keep pullup */                
    R32_PB_DIR |= TXD1;                                                                             /* TXD0 output enable */                                    
}

/*******************************************************************************
* Function Name  : fputc
* Description    : ͨϢ
* Input          : c-- writes the character specified by c 
*                  *f--the output stream pointed to by *f
* Output         : None
* Return         : None
*******************************************************************************/

int fputc( int c, FILE *f )
{
    R8_UART1_THR = c;                                                                               /*  */
    while( ( R8_UART1_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );                                            /* ȴݷ */
    return( c );
}

__asm void jumptoapp(void)
{
	B 0X1000
}


/*******************************************************************************                                                                         
* Function Name  : IRQ_Handler                                                                                                                           
* Description    : IRQжϷ                                                                                                                       
* Input          : None                                                                                                                                  
* Output         : None                                                                                                                                  
* Return         : None                                                                                                                                  
*******************************************************************************/                                                                         
__irq void IRQ_Handler( void )                                                                                                                           
{
;
	
}                                                                                                                                                        

__irq void FIQ_Handler( void )
{
;	
}




 int  main()
 {   
		UINT32 i;
		UINT32 pos=0;
		UINT8 FLAG[2];
		PUINT8 flash = (PUINT8)(68*1024);  
		UINT8  code[4096]; 
		UINT32 code_addr=0x1000;  
	 
	 

    mInitSTDIO( );   
	 	 
	 EEPROM_READ( 20*1024, FLAG, 2 );
	 if((FLAG[0]==0X57)  && (FLAG[1]==0XAB))
	 {                                                                               //tftpճС516ֽڣһBINļһ                               
         printf("*** begin update***\n");
          FLASH_ROM_LOCK(0);		 
          while(code_addr<64*1024)
						{                                                                                                                                                                                                                                                                                                                                                
//								for(i=0;i<4096;i++) 
//								{                                                                    //Ƚbinļflash64KBƵcodeУٴcodeƵflashǰ64kbһ          4kb
//								   code[i]=flash[pos];                                                                                                                                                              
//								   pos++;                                                                                                                                                                           
//								}
						  	memcpy(code,&flash[pos],4096);;
							  pos+=4096;

                i=FLASH_ROM_ERASE( code_addr,4096);
              if(i==0) printf("*****erase ok*****\n"); 
               else     printf("*****erase error*****\n"); 								
								i = FLASH_ROM_WRITE( code_addr,(PVOID)(code),4096 );                                    // ûû0x00000000ַʼ                                                   
              if(i==0) printf("*****write ok*****\n"); 
               else     printf("*****write error*****\n");                                                                                                                                           
								i = FLASH_ROM_VERIFY( code_addr,(PVOID)(code),4096 );                                   // УǷȷ                                                                            
               if(i==0) printf("*****write ok*****\n"); 
               else     printf("*****write error*****\n");                                                                                                                                           
								code_addr+=4096;                                                                                                                                                                    
		            		
           }                                                                                                                                                                                   
          i = FLASH_ROM_ERASE( 1024*64 ,1024*64 );                                                 //flash  
				  EEPROM_ERASE(20*1024,4096);
          FLASH_ROM_LOCK(FLASH_ROM_LOCK_AUTO);  
					R8_SAFE_ACCESS_SIG = 0x57 ;   
					R8_SAFE_ACCESS_SIG = 0xA8 ;    
					R8_GLOB_RST_CFG |= (RB_GLOB_FORCE_RST | 0x40);
					R8_SAFE_ACCESS_SIG = 0;  					 
     }
	          printf("*** jumpto app***\n");    
	 jumptoapp();

		 
}